<template>
  <div>
    <el-card class="el-card">
      <el-form :model="filterQuery" class="query-form" size="mini" :inline="true">
        <el-row>
          <el-form-item class="query-form-item" label="单号:">
            <el-input v-model="filterQuery.billNo" placeholder="单号"
                      clearable="true"></el-input>
          </el-form-item>
          <el-form-item>
            <el-button-group>
              <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
              <el-button type="primary" icon="el-icon-search" @click="getList">查询</el-button>
              <el-button type="primary" icon="el-icon-delete" @click="deleteAllOrder">全部删除</el-button>
              <el-button type="primary" icon="el-icon-edit" @click="editOrders">编辑</el-button>
            </el-button-group>
          </el-form-item>
        </el-row>
      </el-form>
      <el-table v-loading="loading" :data="list" style="width: 100%" highlight-current-row
                border
                @current-change="handleSelectionChange">
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="扫码单据类型" prop="billTypeName"></el-table-column>
        <el-table-column label="订单号" prop="billNo" show-overflow-tooltip></el-table-column>
        <el-table-column label="来源订单号" prop="corpOrderId" show-overflow-tooltip></el-table-column>
        <el-table-column label="来源" prop="fromType">
          <template slot-scope="scope">
            <span>{{ fromTypeMap[scope.row.fromType] }}</span>
          </template>
        </el-table-column>
        <el-table-column label="往来单位" prop="fromCorpName" width="220">
        </el-table-column>
        <el-table-column label="当前部门" prop="deptName" width="120">
        </el-table-column>
        <el-table-column label="当前仓库" prop="invName" width="120">
        </el-table-column>
        <el-table-column label="所属科室" prop="deptName" width="120" v-if="enableDept">
        </el-table-column>
        <el-table-column label="创建时间" prop="createTime" show-overflow-tooltip>
          <template slot-scope="scope">
            <i class="el-icon-time"></i>
            <span>{{ scope.row.createTime }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" width="150">
          <template slot-scope="scope">
            <el-button
              type="text"
              size="small"
              @click.native.stop="showCodes(scope.row)"
            >编辑
            </el-button>
            <el-button
              type="text"
              size="small"
              @click.native.stop="deleteDialog(scope.row)"
            >删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </el-card>

    <el-tabs type="border-card" style="margin: 15px">
      <!--单据业务详情-->
      <el-tab-pane>
        <span slot="label">单据 {{ currentRow.billNo }}-业务详情</span>
        <el-form :inline="true" :model="bizQuery" class="query-form" size="mini">
          <el-form-item class="query-form-item" label="产品名称:">
            <el-input
              v-model="bizQuery.productName"
              placeholder="请输入产品名称"
              clearable
            >
            </el-input>
          </el-form-item>

          <el-form-item>
            <el-button-group>
              <el-button
                type="primary"
                icon="el-icon-refresh"
                @click="onBizReset"
              >重置
              </el-button>
              <el-button type="primary" @click="onBizSubmit"
                         icon="el-icon-search"
              >查询
              </el-button>
            </el-button-group>
          </el-form-item>
        </el-form>

        <el-table v-loading="bizDetailLoading" :data="bizDetailList" style="width: 100%" border
                  row-key="id"
        >
          <el-table-column label="序号" type="index"></el-table-column>
          <el-table-column
            label="产品通用名称"
            prop="coName"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="规格型号"
            prop="spec"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="批次号"
            prop="batchNo"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="生产日期"
            prop="productDate"
          ></el-table-column>
          <el-table-column
            label="失效日期"
            prop="expireDate"
          ></el-table-column>
          <el-table-column
            label="单据数量"
            prop="count"
          ></el-table-column>
          <el-table-column
            label="价格"
            prop="price"
          ></el-table-column>
          <el-table-column
            label="生产厂家"
            prop="manufacturer"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="注册/备案凭证号"
            prop="certCode"
            show-overflow-tooltip
          ></el-table-column>
        </el-table>
        <pagination
          v-show="bizTotal>0"
          :total="bizTotal"
          :page.sync="bizQuery.page"
          :limit.sync="bizQuery.limit"
          @pagination="getBizDetailList"
        />
      </el-tab-pane>

      <!--单据扫码详情-->
      <el-tab-pane>
        <span slot="label">单据 {{ currentRow.billNo }}-扫码详情</span>
        <el-form :inline="true" :model="codeQuery" class="query-form" size="mini">
          <el-form-item class="query-form-item" label="产品名称:">
            <el-input
              v-model="codeQuery.productName"
              placeholder="请输入产品名称"
              clearable
            >
            </el-input>
          </el-form-item>
          <el-form-item>
            <el-button-group>
              <el-button
                type="primary"
                icon="el-icon-refresh"
                @click="onCodeReset"
              >重置
              </el-button>
              <el-button type="primary" @click="onCodeSubmit"
                         icon="el-icon-search"
              >查询
              </el-button>
            </el-button-group>
          </el-form-item>
        </el-form>

        <el-table v-loading="codeDetailLoading" :data="codeDetailList" style="width: 100%" border
                  row-key="id"
        >
          <el-table-column label="序号" type="index"></el-table-column>
          <el-table-column
            label="产品通用名"
            prop="coName"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="规格型号"
            prop="spec"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="批次号"
            prop="batchNo"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="生产日期"
            prop="productDate"
          ></el-table-column>
          <el-table-column
            label="失效日期"
            prop="expireDate"
          ></el-table-column>
          <el-table-column
            label="单据数量"
            prop="count"
          ></el-table-column>
          <el-table-column
            label="扫码数量"
            prop="reCount"
          ></el-table-column>
          <el-table-column
            label="供应商"
            prop="supName"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="生产厂家"
            prop="manufacturer"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="注册/备案凭证号"
            prop="certCode"
            show-overflow-tooltip
          ></el-table-column>
        </el-table>
        <pagination
          v-show="codeTotal>0"
          :total="codeTotal"
          :page.sync="codeQuery.page"
          :limit.sync="codeQuery.limit"
          @pagination="getCodeDetailList"
        />
      </el-tab-pane>

      <!--单据扫码明细-->
      <el-tab-pane>
        <span slot="label">单据 {{ currentRow.billNo }}-扫码明细</span>
        <el-form :inline="true" :model="resultQuery" class="query-form" size="mini">
          <el-form-item class="query-form-item" label="产品名称:">
            <el-input
              v-model="resultQuery.code"
              placeholder="请输入UDI码"
              clearable
            >
            </el-input>
          </el-form-item>
          <el-form-item>
            <el-button-group>
              <el-button
                type="primary"
                icon="el-icon-refresh"
                @click="onResultReset"
              >重置
              </el-button>
              <el-button type="primary" @click="onResultSubmit"
                         icon="el-icon-search"
              >查询
              </el-button
              >
            </el-button-group>
          </el-form-item>
        </el-form>

        <el-table v-loading="resultDetailLoading" :data="resultDetailList" style="width: 100%" border
                  row-key="id"
        >
          <el-table-column label="序号" type="index"></el-table-column>
          <el-table-column
            label="UDI码"
            prop="code"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="生产日期"
            prop="produceDate"
            width="120"
          ></el-table-column>
          <el-table-column
            label="失效日期"
            prop="expireDate"
            width="120"
          ></el-table-column>
          <el-table-column
            label="批次号"
            prop="batchNo"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="序列号"
            prop="serialNo"
          ></el-table-column>
          <el-table-column
            label="供应商"
            prop="supName"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="扫码数量"
            prop="reCount"
          ></el-table-column>
          <el-table-column
            label="实际数量"
            prop="reCount"
          ></el-table-column>
        </el-table>
        <pagination
          v-show="resultTotal>0"
          :total="resultTotal"
          :page.sync="resultQuery.page"
          :limit.sync="resultQuery.limit"
          @pagination="getResultDetailList"
        />
      </el-tab-pane>
    </el-tabs>

    <el-dialog
      title="编辑时间"
      :visible.sync="editDialogVisible"
      width="45%"
      append-to-body
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      v-if="editDialogVisible"
    >
      <el-form label-width="100px">
        <el-row>
          <el-col :span="14">
            <el-form-item label="创建时间:">
              <el-date-picker
                v-model="createTime"
                type="datetime"
                value-format="yyyy-MM-dd HH:mm:ss"
                :picker-options="pickerOptions"
                placeholder="选择日期时间"
                style="width: 90%"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="14">
            <el-form-item label="审核时间:">
              <el-date-picker
                v-model="auditTime"
                type="datetime"
                value-format="yyyy-MM-dd HH:mm:ss"
                :picker-options="pickerOptions"
                placeholder="选择日期"
                style="width: 90%"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>

      <div style="text-align: right; margin-top: 10px;">
        <el-button type="primary" size="small" icon="search" @click="updateOrderInfo"
        >提交
        </el-button
        >
        <el-button type="primary" size="small" icon="search" @click="editDialogVisible = !editDialogVisible"
        >取消
        </el-button
        >
      </div>
    </el-dialog>

    <el-dialog
      title="详情"
      :visible.sync="codeDialogVisible"
      width="60%"
      append-to-body
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      v-if="codeDialogVisible"
    >
      <IoEditOrderCodeDetail
        :order="order"
        :getOrderList="getList"
      ></IoEditOrderCodeDetail>
    </el-dialog>

  </div>
</template>

<script>
import {
  deleteByOrderId,
  filterOrderTrace, updateOrderInfo, deleteInvByBillNo
} from "../../api/inout/order";
import {isBlank} from "@/utils/strUtil";
import {getBizDetailList} from "@/api/inout/orderDetailBiz";
import {getCodeDetailList} from "@/api/inout/orderDetailCode";
import {getCodeList} from "@/api/inout/code";
import IoEditOrderCodeDetail from "@/views/inout/IoEditOrderCodeDetail.vue";


const formJson = {
  site_id: "",
  site_name: "",
  describe: "",
  ads: [],
};

export default {
  name: "IoEditOrder",
  data() {
    return {
      filterQuery: {
        billNo: null
      },
      checkStatus: {
        1: "草稿",
        2: "等待处理",
        3: "等待校验",
        4: "处理异常",
        5: "校验成功",
        6: "校验异常",
        7: "审核通过",
        8: "审核拒绝"
      },
      invList: [],
      list: [],
      loading: false,
      index: null,
      enableDept: false,
      fromTypeMap: {
        "1": "UDIMS平台",
        "2": "网页新增",
        "3": "pda即时校验",
        "4": "pda未校验",
        "5": "pc端扫码精灵",
        "6": "缺量补录单据",
        "7": "UDI供应商平台",
        "8": "平衡补录单据",
        "10": "手动补单",
        "11": "仓库盘点",
        "12": "采购计划",
        "13": "领用单据",
        "14": "第三方系统单据",
      },
      deleteData: {
        id: "",
      },
      formLoading: false,
      dialogVisible: false,
      formData: formJson,
      deleteLoading: false,
      busTypes: [],
      currentRow: {
        billNo: null,
      },
      bizQuery: {
        productName: null,
        orderIdFk: null,
        page: 1,
        limit: 10
      },
      bizTotal: 0,
      bizDetailLoading: false,
      bizDetailList: [],
      codeQuery: {
        orderIdFk: null,
        page: 1,
        limit: 10
      },
      codeTotal: 0,
      codeDetailLoading: false,
      codeDetailList: [],
      resultQuery: {
        orderId: null,
        code: null,
        page: 1,
        limit: 10
      },
      resultTotal: 0,
      resultDetailLoading: false,
      resultDetailList: [],
      editDialogVisible: false,
      createTime: null, //创建时间
      auditTime: null, //审核时间
      orderIds: [],
      pickerOptions: {
        disabledDate: time => {
          let endDate = new Date().getTime();
          let nowDate = new Date(time).getTime();
          return (nowDate > endDate);
        }
      },
      order: {},
      codeDialogVisible: false
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.filterQuery = {
        billNo: null
      };
      this.currentRow.billNo = null;
      this.list = [];
      this.clearDetailList();
    },
    handleSelectionChange(val) {
      if (null === val) {
        return;
      }
      this.currentRow = val;
      this.getOrderDetails();
    },
    // 获取单据 业务详情、扫码详情、扫码明细
    getOrderDetails() {
      this.bizQuery.page = 1;
      this.codeQuery.page = 1;
      this.resultQuery.page = 1;

      this.getBizDetailList();
      this.getCodeDetailList();
      this.getResultDetailList();
    },
    // 清空单据详情数据列表
    clearDetailList() {
      // 清空业务详情
      this.bizDetailList = [];
      this.bizTotal = 0;
      // 清空扫码详情
      this.codeDetailList = [];
      this.codeTotal = 0;
      // 清空扫码明细
      this.resultDetailList = [];
      this.resultTotal = 0;
    },
    //获取订单列表
    getList() {
      if (isBlank(this.filterQuery.billNo)) {
        return;
      }
      this.loading = true;
      this.currentRow = {billNo: ""};
      this.orderIds = [];
      this.clearDetailList();
      filterOrderTrace(this.filterQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.list = response.data || [];
            this.list.forEach((item) => {
              this.orderIds.push(item.billNo);
            });
          } else {
            this.$message.error(response.message);
          }
        })
        .catch((error) => {
          this.$message.error(error.message)
          this.loading = false;
          this.list = [];
        });
    },
    deleteAllOrder() {
      if (this.list.length > 0) {
        this.$confirm("是否确认删除此单据和所有关联单据？", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }).then(() => {
          let billNos = [];
          this.list.forEach(item => {
            billNos.push(item.billNo);
          });
          let params = {
            billNos: billNos
          };
          deleteInvByBillNo(params).then((res) => {
            if (res.code === 20000) {
              this.$message.success("删除成功");
              this.list = [];
              this.detailList = [];
              this.clearDetailList();
              this.filterQuery.billNo = null;
              this.currentRow.billNo = "";
            }
          }).catch((error) => {
            this.$message.error("删除失败");
          })
        }).catch(() => {
        });
      }
    },
    editOrders() {
      if (this.list.length > 0) {
        this.createTime = null;
        this.auditTime = null;
        this.editDialogVisible = true;
      }
    },
    updateOrderInfo() {
      if (isBlank(this.createTime)) {
        this.$message.warning("创建时间不能为空");
        return;
      }
      if (isBlank(this.auditTime)) {
        this.$message.warning("审核时间不能为空");
        return;
      }
      this.editDialogVisible = false;
      let params = {
        createTime: this.createTime,
        auditTime: this.auditTime,
        orderIds: this.orderIds
      };
      updateOrderInfo(params).then((res) => {
        if (res.code === 20000) {
          this.$message.success("修改成功");
          this.getList();
        }
      }).catch((error) => {
        this.$message.error(error.message);
      })
    },
    deleteDialog(row) {
      this.$confirm("此操作将永久删除该订单, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          let query = {billNo: row.billNo};
          deleteInvByBillNo(query).then((res) => {
            if (res.code === 20000) {
              this.$message.success("修改成功");
              this.getList();
            }
          }).catch((error) => {
            this.$message.error(error.message);
          })

        })
        .catch(() => {
        });
    },
    onBizReset() {
      this.bizQuery = {
        productName: null,
        orderIdFk: null,
        page: 1,
        limit: 10
      };
      this.getBizDetailList();
    },
    onBizSubmit() {
      this.bizQuery.page = 1;
      this.getBizDetailList();
    },
    getBizDetailList() {
      if (isBlank(this.currentRow.billNo)) {
        this.$message.error("请先选择需要查询的单据！");
        return;
      }
      this.bizDetailLoading = true;
      this.bizQuery.orderIdFk = this.currentRow.billNo;
      getBizDetailList(this.bizQuery).then((res) => {
        this.bizDetailLoading = false;
        if (res.code === 20000) {
          this.bizDetailList = res.data.list || [];
          this.bizTotal = res.data.total || 0;
        } else {
          this.$message.error(res.message);
          this.bizDetailList = [];
          this.bizTotal = 0;
        }
      }).catch((error) => {
        this.bizDetailLoading = false;
        this.$message.error(error.message);
        this.bizDetailList = [];
        this.bizTotal = 0;
      })
    },
    onCodeReset() {
      this.codeQuery = {
        orderIdFk: null,
        page: 1,
        limit: 10
      };
      this.getCodeDetailList();
    },
    onCodeSubmit() {
      this.codeQuery.page = 1;
      this.getCodeDetailList();
    },
    getCodeDetailList() {
      if (isBlank(this.currentRow.billNo)) {
        this.$message.error("请先选择需要查询的单据！")
        return;
      }

      this.codeQuery.orderIdFk = this.currentRow.billNo;
      this.codeDetailLoading = true;
      getCodeDetailList(this.codeQuery).then((res) => {
        this.codeDetailLoading = false;
        if (res.code === 20000) {
          this.codeDetailList = res.data.list || [];
          this.codeTotal = res.data.total || 0;
        } else {
          this.$message.error(res.message);
          this.codeDetailList = [];
          this.codeTotal = 0;
        }
      }).catch((error) => {
        this.codeDetailLoading = true;
        this.$message.error(error.message);
        this.codeDetailList = [];
        this.codeTotal = 0;
      })
    },
    onResultReset() {
      this.resultQuery = {
        orderId: null,
        code: null,
        page: 1,
        limit: 10
      };
      this.getResultDetailList();
    },
    onResultSubmit() {
      this.resultQuery.page = 1;
      this.getResultDetailList();
    },
    getResultDetailList() {
      if (isBlank(this.currentRow.billNo)) {
        this.$message.error("请先选择需要查询的单据！")
        return;
      }

      this.resultQuery.orderId = this.currentRow.billNo;
      this.resultDetailLoading = true;
      getCodeList(this.resultQuery).then((res) => {
        this.resultDetailLoading = false;
        if (res.code === 20000) {
          this.resultDetailList = res.data.list || [];
          this.resultTotal = res.data.total || 0;
        } else {
          this.$message.error(res.message);
          this.resultDetailList = [];
          this.resultTotal = 0;
        }
      }).catch((error) => {
        this.resultDetailLoading = false;
        this.$message.error(error.message);
        this.resultDetailList = [];
        this.resultTotal = 0;
      });
    },
    showCodes(row) {
      this.order.billNo = row.billNo;
      this.codeDialogVisible = true;
    },
  },
  filters: {
    statusFilterType(status) {
      const statusMap = {
        false: "success",
        true: "warning",
      };
      return statusMap[status];
    },
  },
  mounted() {
    document.body.ondrop = function (event) {
      event.preventDefault();
      event.stopPropagation();
    };
  },
  components: {
    IoEditOrderCodeDetail
  },
  created() {

  },
};
</script>

<style type="text/scss" lang="scss">
</style>
